---
title: 'ServiceWorkerContainer: message event'
slug: Web/API/ServiceWorkerContainer/message_event
tags:
  - API
  - Event
  - Reference
  - Service Workers
---
<div>{{APIRef}}</div>

<p>The <code><strong>message</strong></code> event is used in a page controlled by a service worker to receive messages from the service worker.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("MessageEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td><code><a href="/en-US/docs/Web/API/ServiceWorkerContainer/onmessage">onmessage</a></code></td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<p>In this example the service worker get the client's ID from a <a href="/en-US/docs/Web/API/ServiceWorkerGlobalScope/onfetch"><code>fetch</code></a> event and then sends it a message using <a href="/en-US/docs/Web/API/Client/postMessage"><code>Client.postMessage</code></a>:</p>

<pre class="brush: js">// in the service worker
async function messageClient(clientId) {
    const client = await clients.get(clientId);
    client.postMessage('Hi client!');
}

addEventListener('fetch', (event) =&gt; {
    messageClient(event.clientId);
    event.respondWith(() =&gt; {
      // ...
    });
});</pre>

<p>The client can receive the message by listening to the <code>message</code> event:</p>

<pre class="brush: js">// in the page being controlled
navigator.serviceWorker.addEventListener('message', (message) =&gt; {
    console.log(message);
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#dom-serviceworkercontainer-onmessage', 'message')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.ServiceWorkerContainer.message_event")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Service_Worker_API/Using_Service_Workers">Using Service Workers</a></li>
 <li><a class="external external-icon" href="https://github.com/mdn/sw-test">Service workers basic code example</a></li>
 <li><a class="external external-icon" href="https://jakearchibald.github.io/isserviceworkerready/">Is ServiceWorker ready?</a></li>
 <li><a href="/en-US/docs/Web/API/Web_Workers_API/Using_web_workers">Using web workers</a></li>
</ul>
